#ifdef AUDIO_H
#error Double include.
#endif
#define AUDIO_H

enum {
    MAXMIDI_GUESS = 25,
    MAXWAVE_GUESS = 99,
    Mid_None      =  0,
    Sound_Left    =  1,
    Sound_Right   =  2,
    Sound_Center  =  3
};

class miDSound {
    public:                  miDSound       (void);
                             ~miDSound      (void);
    bool                     LoadWaveFile   (TCHAR* strFileName);
    bool                     PlayBuffer     (bool bLooped);
    bool                     IsPlaying      (void);
    void                     StopBuffer     (bool bResetPosition);

    private:
    bool                     FillBuffer     (void);
    WAVEFORMATEX             *m_pwfx;
    LPDIRECTSOUNDBUFFER      g_pDSBuffer;
    LPDIRECTSOUNDNOTIFY      g_pDSNotify;
    HMMIO                    m_hmmioIn;
    MMCKINFO                 m_ckIn;
    MMCKINFO                 m_ckInRiff;
    DWORD                    g_dwBufferBytes;
};

class CAudio {
    public:                  CAudio         (void);
    void                     Init           (unsigned, unsigned, unsigned, unsigned);
    void                     Destroy        (void);
    void                     Update         (void);
    void                     Suspend        (void);
    void                     SetVolume      (unsigned);
    void                     Sound          (unsigned);
    void                     Music          (unsigned, unsigned rl = 0);
    void                     SetPan         (unsigned);
    LPDIRECTSOUND            lpDirectSound;
    int                      pan;
    unsigned                 volume,
                             offset_midi,
                             offset_wave;
    bool                     music_on,
                             sound_on;

    private:
    int                      sound,
                             music,
                             directsound,
                             directmusic;
    unsigned                 curmusic,
                             newmusic,
                             rnd_music,
                             rnd_last,
                             maxsound,
                             maxmusic;
    char                     MidiStr        [256],
                             TempFile       [256];
    IDirectMusicPerformance  *pPerf;
    IDirectMusicLoader       *pLoader;
    IDirectMusicSegment      *pMIDISeg;
    DMUS_OBJECTDESC          ObjDesc        [MAXMIDI_GUESS];
    unsigned char            *MidiBuffer    [MAXMIDI_GUESS];
    LPDIRECTSOUNDBUFFER      basesound;
    miDSound                 soundfx        [MAXWAVE_GUESS];
    char                     *soundbuf      [MAXWAVE_GUESS];
};

extern CAudio Audio;
