#ifdef SOCKET_H
#error Double include.
#endif
#define SOCKET_H

#ifdef USE_SOCKET
#define _stub0_ ;
#define _stub1_ ;
#else
#define _stub0_ { }
#define _stub1_ { return 0; }
#endif

enum {
    DEFAULT_PORT = 0x2308,
    MAX_LINK     =      8,
    MAX_HOSTNAME =    255,
    MAX_BUFFER   =  65536,
    SIG_ABORT    = 0x1234
};

enum SocketState {
    SK_Disabled,
    SK_Inactive,
    SK_Server,
    SK_Client,
    SK_ClientBroken
};

class CPSocket {
    public:     CPSocket   (void)                  _stub0_
                ~CPSocket  (void)                  _stub0_
    void        Init       (void)                  _stub0_
    bool        InitServer (void)                  _stub1_
    bool        InitClient (void)                  _stub1_
    void        DeInit     (void)                  _stub0_
    void        Update     (void)                  _stub0_
    void        SetLink    (unsigned)              _stub0_
    bool        CheckOwner (unsigned)              _stub1_
    void        SetOwner   (unsigned, bool)        _stub0_
    void        SendByte   (char)                  _stub0_
    void        SendWord   (short)                 _stub0_
    void        SendDW     (unsigned)              _stub0_
    void        Send       (const void*, unsigned) _stub0_
    void        Unlink     (void)                  _stub0_
    char        RecvByte   (void)                  _stub1_
    short       RecvWord   (void)                  _stub1_
    unsigned    RecvDW     (void)                  _stub1_
    void        Recv       (void*, unsigned)       _stub0_
    void        RecvSkip   (unsigned)              _stub0_
    unsigned    port;
    char        hostname   [MAX_HOSTNAME],
                usename    [MAX_HOSTNAME];
    SocketState state;

    private:
    bool        GetHost    (const char*);
    void        SetAsync   (unsigned);
    unsigned    link,
                sendpos,
                owner      [MAX_LINK * 2],
                recvpos    [MAX_LINK],
                recvend    [MAX_LINK];
    SOCKADDR_IN addr;
    SOCKET      svr,
                sock       [MAX_LINK];
    char        sendbuf    [MAX_BUFFER],
                recvbuf    [MAX_LINK][MAX_BUFFER];
};

extern CPSocket Socket;
